Subject: Re: bug#21465: [PATCH] CC-modes hierarchy

From: Mark Oteiza <[email-masked]>
Date: Sun, 13 Sep 2015 17:18:01 -0400

On 13/09/15 at 04:24pm, Stefan Monnier wrote:
> > Nope, for some reason, doing (c-make-inherited-keymap) in the map
> > definition in 24, I end up only with a Foo++ menu.  Simply using
> > (make-keymap), I'd end with with both Foo++ and C++ menus.
> 
> Oh, you mean that your code uses c-make-inherited-keymap and the change
> breaks your code, so you then try to fix it by replacing it with
> make-sparse-keymap or make-keymap.
> 
> Indeed, that's not the right fix.  The right fix is to complain about
> the removal of c-make-inherited-keymap because it is used by external
> CC-mode modes.
> 
> BTW, you don't need c-make-inherited-keymap.  Instead you need
> 
>    (defvar foo++-mode-map
>      (let ((map (make-sparse-keymap)))
>        (set-keymap-parent map c-mode-base-map)
>        ...
>        map))
> 
> This should be just as backward compatible as using
> c-make-inherited-keymap (and "backward" includes XEmacs, here).

That works, thanks.

> >> > when there shouldn't be, or:
> >> > (define-derived-mode foo++-mode c-derivative-mode "Foo++"
> >> >  ...)
> >> > and fontification is broken.
> >> 
> >> How is it broken?
> 
> > Oh, it was broken because I was using (make-syntax-table) instead of
> > (funcall (c-lang-const c-make-mode-syntax-table c)). It looks like
> > c-derivative-mode comes with no syntax table, which is alright.
> 
> Indeed, we could set C's syntax table in c-derivative-mode.  That would
> make a lot of sense, thanks.  The proposed patch just introduces
> c-derivative-mode as a way to make the hierarchy more visible, but it
> doesn't make c-derivative-mode usable on its own.  You could argue that
> c-derivative-mode should be the same as c-mode, but my patch does not
> try to do that (yet?).

Oh, and I guess it's not necessary to do the (funcall …) since it's
already c-mode-syntax-table. Similar to the keymap, I can do

 (set-char-table-parent table c-mode-syntax-table)

It would be nice if c-derivative-mode did that work for us.

Then, if I didn't want the c-mode keymap or syntax table, I could set
the parent of my derived table to nil. That's what I did for a mode that
I recently made derive from conf-mode. I didn't want conf-mode's keymap.